OGRE: Ogre::D3D11GpuProgramManager Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::D3D11GpuProgramManager Class Reference

`#include <OgreD3D11GpuProgramManager.h>`

Inheritance diagram for Ogre::D3D11GpuProgramManager:
[legend]

## Public Types
typedef MemoryDataStreamPtr | Microcode
typedef map< Hash, Microcode >::type | MicrocodeMap
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap
typedef map< String, GpuSharedParametersPtr >::type | SharedParametersMap
typedef set< String >::type | SyntaxCodes

## Public Member Functions
| D3D11GpuProgramManager ()
| ~D3D11GpuProgramManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded. More...
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e. More...
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded. More...
virtual void | addMicrocodeToCache (const String &source, const Microcode &microcode)
| Adds a microcode for a program to the microcode cache. More...
bool | canGetCompiledShaderBuffer ()
virtual void | clearMicrocodeCache (void)
| Deletes all microcodes. Useful when hot reloading. More...
virtual ResourcePtr | create (const String &name, const String &group, GpuProgramType gptype, const String &syntaxCode, bool isManual=false, ManualResourceLoader *loader=0)
| General create method, using specific create parameters instead of name / value pairs. More...
virtual Microcode | createMicrocode (const uint32 size) const
| Creates a microcode to be later added to the cache. More...
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists. More...
virtual GpuProgramParametersSharedPtr | createParameters (void)
| Creates a new GpuProgramParameters instance which can be used to bind parameters to your programs. More...
virtual GpuProgramPtr | createProgram (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Create a new, unloaded GpuProgram from a file of assembly. More...
virtual GpuProgramPtr | createProgramFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Create a GPU program from a string of assembly code. More...
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it. More...
virtual GpuSharedParametersPtr | createSharedParameters (const String &name)
| Create a new set of shared parameters, which can be used across many GpuProgramParameters objects of different structures. More...
void | destroyAllResourcePools ()
| destroy all pools More...
void | destroyResourcePool (const String &name)
| Destroy a resource pool. More...
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool. More...
virtual const SharedParametersMap & | getAvailableSharedParameters () const
| Get (const) access to the available shared parameter sets. More...
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist. More...
GpuProgramPtr | getByName (const String &name, bool preferHighLevelPrograms=true)
| Get a resource by name. More...
virtual Real | getLoadingOrder (void) const
| Gets the relative loading order of resources of this type. More...
virtual size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use. More...
virtual size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes. More...
virtual const Microcode & | getMicrocodeFromCache (const String &source) const
| Returns a microcode for a program from the microcode cache. More...
ResourcePtr | getResourceByName (const String &name, bool preferHighLevelPrograms=true)
| Overrides the standard ResourceManager getResourceByName method. More...
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist. More...
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager. More...
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists. More...
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles. More...
bool | getSaveMicrocodesToCache ()
| Get if the microcode of a shader should be saved to a cache. More...
virtual const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this ResourceManager. More...
virtual GpuSharedParametersPtr | getSharedParameters (const String &name) const
| Retrieve a set of shared parameters, which can be used across many GpuProgramParameters objects of different structures. More...
virtual const SyntaxCodes & | getSupportedSyntax (void) const
| Returns the syntaxes that this manager supports. More...
virtual bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output. More...
bool | isCacheDirty (void) const
| Returns true if the microcodecache changed during the run. More...
virtual bool | isMicrocodeAvailableInCache (const String &source) const
| Check if a microcode is available for a program in the microcode cache. More...
virtual bool | isSyntaxSupported (const String &syntaxCode) const
| Returns whether a given syntax code (e.g. More...
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters). More...
virtual GpuProgramPtr | load (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a file of assembly. More...
virtual GpuProgramPtr | loadFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a string of assembly code. More...
virtual void | loadMicrocodeCache (DataStreamPtr stream)
| Loads the microcode cache from disk. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | parseScript (DataStreamPtr &stream, const String &groupName)
| Parse the definition of a set of resources from a script file. More...
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters). More...
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded. More...
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded. More...
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded. More...
virtual void | remove (const ResourcePtr &r)
| Remove a single resource. More...
virtual void | remove (const String &name)
| Remove a single resource by name. More...
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle. More...
virtual void | removeAll (void)
| Removes all resources. More...
virtual void | removeMicrocodeFromCache (const String &source)
| Removes a microcode for a program from the microcode cache. More...
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object. More...
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager. More...
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager. More...
virtual void | saveMicrocodeCache (DataStreamPtr stream) const
| Saves the microcode cache to disk. More...
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use. More...
void | setSaveMicrocodesToCache (const bool val)
| Set if the microcode of a shader should be saved to a cache. More...
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output. More...
virtual void | unload (const String &name)
| Unloads a single resource by name. More...
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle. More...
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources. More...
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources. More...
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object. More...

## Static Public Member Functions
static GpuProgramManager & | getSingleton (void)
| Override standard Singleton retrieval. More...
static GpuProgramManager * | getSingletonPtr (void)
| Override standard Singleton retrieval. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Member Typedef Documentation

## ◆ Microcode

typedef MemoryDataStreamPtr Ogre::GpuProgramManager::Microcode
| inherited

## ◆ MicrocodeMap

typedef map<Hash, Microcode>::type Ogre::GpuProgramManager::MicrocodeMap
| inherited

## ◆ ResourceCreateOrRetrieveResult

typedef std::pair<ResourcePtr, bool> Ogre::ResourceManager::ResourceCreateOrRetrieveResult
| inherited

## ◆ ResourceHandleMap

typedef map<ResourceHandle, ResourcePtr>::type Ogre::ResourceManager::ResourceHandleMap
| inherited

## ◆ ResourceMap

typedef unordered_map< String, ResourcePtr >::type Ogre::ResourceManager::ResourceMap
| inherited

## ◆ ResourceMapIterator

typedef MapIterator<ResourceHandleMap> Ogre::ResourceManager::ResourceMapIterator
| inherited

## ◆ ResourceWithGroupMap

typedef unordered_map< String, ResourceMap >::type Ogre::ResourceManager::ResourceWithGroupMap
| inherited

## ◆ SharedParametersMap

typedef map<String, GpuSharedParametersPtr>::type Ogre::GpuProgramManager::SharedParametersMap
| inherited

## ◆ SyntaxCodes

typedef set<String>::type Ogre::GpuProgramManager::SyntaxCodes
| inherited

## Constructor & Destructor Documentation

## ◆ D3D11GpuProgramManager()

Ogre::D3D11GpuProgramManager::D3D11GpuProgramManager | ( |  | ) |

## ◆ ~D3D11GpuProgramManager()

Ogre::D3D11GpuProgramManager::~D3D11GpuProgramManager | ( |  | ) |

## Member Function Documentation

## ◆ _notifyResourceLoaded()

virtual void Ogre::ResourceManager::_notifyResourceLoaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been loaded.

## ◆ _notifyResourceTouched()

virtual void Ogre::ResourceManager::_notifyResourceTouched | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been 'touched', i.e.

used.

## ◆ _notifyResourceUnloaded()

virtual void Ogre::ResourceManager::_notifyResourceUnloaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been unloaded.

## ◆ addMicrocodeToCache()

virtual void Ogre::GpuProgramManager::addMicrocodeToCache | ( | const String & | source,
|  | const Microcode & | microcode
| ) |  |
| virtualinherited

Adds a microcode for a program to the microcode cache.

Parameters

  name | The name of the program.

## ◆ canGetCompiledShaderBuffer()

bool Ogre::GpuProgramManager::canGetCompiledShaderBuffer | ( |  | ) |
| inherited

## ◆ clearMicrocodeCache()

virtual void Ogre::GpuProgramManager::clearMicrocodeCache | ( | void |  | ) |
| virtualinherited

Deletes all microcodes. Useful when hot reloading.

## ◆ create()

virtual ResourcePtr Ogre::GpuProgramManager::create | ( | const String & | name,
|  | const String & | group,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |  |
| virtualinherited

General create method, using specific create parameters instead of name / value pairs.

## ◆ createMicrocode()

virtual Microcode Ogre::GpuProgramManager::createMicrocode | ( | const uint32 | size | ) | const
| virtualinherited

Creates a microcode to be later added to the cache.

Parameters

  size | The size of the microcode in bytes

## ◆ createOrRetrieve()

virtual ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Create a new resource, or retrieve an existing one with the same name if it already exists.

Remarks
  This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

See also
  ResourceManager::createResource
  ResourceManager::getResourceByName

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

## ◆ createParameters()

virtual GpuProgramParametersSharedPtr Ogre::GpuProgramManager::createParameters | ( | void |  | ) |
| virtualinherited

Creates a new GpuProgramParameters instance which can be used to bind parameters to your programs.

Remarks
  Program parameters can be shared between multiple programs if you wish.

## ◆ createProgram()

virtual GpuProgramPtr Ogre::GpuProgramManager::createProgram | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | filename,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode
| ) |  |
| virtualinherited

Create a new, unloaded GpuProgram from a file of assembly.

Remarks
  Use this method in preference to the 'load' methods if you wish to define a GpuProgram, but not load it yet; useful for saving memory.

  This method creates a new program of the type specified as the second parameter. As with all types of ResourceManager, this class will search for the file in all resource locations it has been configured to look in.

Parameters

  name | The name of the program
  groupName | The name of the resource group
  filename | The file to load
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1
  gptype | The type of program to create

## ◆ createProgramFromString()

virtual GpuProgramPtr Ogre::GpuProgramManager::createProgramFromString | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | code,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode
| ) |  |
| virtualinherited

Create a GPU program from a string of assembly code.

Remarks
  Use this method in preference to the 'load' methods if you wish to define a GpuProgram, but not load it yet; useful for saving memory.

  The assembly code must be compatible with this manager - call the getSupportedSyntax method for details of the supported syntaxes

Parameters

  name | The identifying name to give this program, which can be used to retrieve this program later with getByName.
  groupName | The name of the resource group
  code | A string of assembly code which will form the program to run
  gptype | The type of program to create.
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ createResource()

virtual ResourcePtr Ogre::ResourceManager::createResource | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Creates a new blank resource, but does not immediately load it.

Remarks
  Resource managers handle disparate types of resources, so if you want to get at the detailed interface of this resource, you'll have to cast the result to the subclass you know you're creating.

Parameters

  name | The unique name of the resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

## ◆ createSharedParameters()

virtual GpuSharedParametersPtr Ogre::GpuProgramManager::createSharedParameters | ( | const String & | name | ) |
| virtualinherited

Create a new set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.

Parameters

  name | The name to give the shared parameters so you can refer to them later.

## ◆ destroyAllResourcePools()

void Ogre::ResourceManager::destroyAllResourcePools | ( |  | ) |
| inherited

destroy all pools

## ◆ destroyResourcePool() [1/2]

void Ogre::ResourceManager::destroyResourcePool | ( | const String & | name | ) |
| inherited

Destroy a resource pool.

## ◆ destroyResourcePool() [2/2]

void Ogre::ResourceManager::destroyResourcePool | ( | ResourcePool * | pool | ) |
| inherited

Destroy a resource pool.

## ◆ getAvailableSharedParameters()

virtual const SharedParametersMap& Ogre::GpuProgramManager::getAvailableSharedParameters | ( |  | ) | const
| virtualinherited

Get (const) access to the available shared parameter sets.

## ◆ getByHandle()

virtual ResourcePtr Ogre::ResourceManager::getByHandle | ( | ResourceHandle | handle | ) |
| virtualinherited

Retrieves a pointer to a resource by handle, or null if the resource does not exist.

## ◆ getByName()

GpuProgramPtr Ogre::GpuProgramManager::getByName | ( | const String & | name,
|  | bool | preferHighLevelPrograms = `true`
| ) |  |
| inherited

Get a resource by name.

See also
  GpuProgramManager::getResourceByName

## ◆ getLoadingOrder()

virtual Real Ogre::ResourceManager::getLoadingOrder | ( | void |  | ) | const
| inlinevirtualinherited

Gets the relative loading order of resources of this type.

Remarks
  There are dependencies between some kinds of resource in terms of loading order, and this value enumerates that. Higher values load later during bulk loading tasks.

Implements Ogre::ScriptLoader.

## ◆ getMemoryBudget()

virtual size_t Ogre::ResourceManager::getMemoryBudget | ( | void |  | ) | const
| virtualinherited

Get the limit on the amount of memory this resource handler may use.

## ◆ getMemoryUsage()

virtual size_t Ogre::ResourceManager::getMemoryUsage | ( | void |  | ) | const
| inlinevirtualinherited

Gets the current memory usage, in bytes.

## ◆ getMicrocodeFromCache()

virtual const Microcode& Ogre::GpuProgramManager::getMicrocodeFromCache | ( | const String & | source | ) | const
| virtualinherited

Returns a microcode for a program from the microcode cache.

Parameters

  name | The name of the program.

## ◆ getResourceByName() [1/2]

ResourcePtr Ogre::GpuProgramManager::getResourceByName | ( | const String & | name,
|  | bool | preferHighLevelPrograms = `true`
| ) |  |
| inherited

Overrides the standard ResourceManager getResourceByName method.

Parameters

  name | The name of the program to retrieve
  preferHighLevelPrograms | If set to true (the default), high level programs will be returned in preference to low-level programs.

## ◆ getResourceByName() [2/2]

virtual ResourcePtr Ogre::ResourceManager::getResourceByName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |
| virtualinherited

Retrieves a pointer to a resource by name, or null if the resource does not exist.

## ◆ getResourceIterator()

ResourceMapIterator Ogre::ResourceManager::getResourceIterator | ( | void |  | ) |
| inlineinherited

Returns an iterator over all resources in this manager.

Note
  Use of this iterator is NOT thread safe!

## ◆ getResourcePool()

ResourcePool* Ogre::ResourceManager::getResourcePool | ( | const String & | name | ) |
| inherited

Create a resource pool, or reuse one that already exists.

## ◆ getResourceType()

const String& Ogre::ResourceManager::getResourceType | ( | void |  | ) | const
| inlineinherited

Gets a string identifying the type of resource this manager handles.

## ◆ getSaveMicrocodesToCache()

bool Ogre::GpuProgramManager::getSaveMicrocodesToCache | ( |  | ) |
| inherited

Get if the microcode of a shader should be saved to a cache.

## ◆ getScriptPatterns()

virtual const StringVector& Ogre::ResourceManager::getScriptPatterns | ( | void |  | ) | const
| inlinevirtualinherited

Gets the file patterns which should be used to find scripts for this ResourceManager.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

  This method lets you determine the file pattern which will be used to identify scripts intended for this manager.

Returns
  A list of file patterns, in the order they should be searched in.

See also
  isScriptingSupported, parseScript

Implements Ogre::ScriptLoader.

## ◆ getSharedParameters()

virtual GpuSharedParametersPtr Ogre::GpuProgramManager::getSharedParameters | ( | const String & | name | ) | const
| virtualinherited

Retrieve a set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.

## ◆ getSingleton()

static GpuProgramManager& Ogre::GpuProgramManager::getSingleton | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static GpuProgramManager* Ogre::GpuProgramManager::getSingletonPtr | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSupportedSyntax()

virtual const SyntaxCodes& Ogre::GpuProgramManager::getSupportedSyntax | ( | void |  | ) | const
| virtualinherited

Returns the syntaxes that this manager supports.

## ◆ getVerbose()

virtual bool Ogre::ResourceManager::getVerbose | ( | void |  | ) |
| inlinevirtualinherited

Gets whether this manager and its resources habitually produce log output.

## ◆ isCacheDirty()

bool Ogre::GpuProgramManager::isCacheDirty | ( | void |  | ) | const
| inherited

Returns true if the microcodecache changed during the run.

## ◆ isMicrocodeAvailableInCache()

virtual bool Ogre::GpuProgramManager::isMicrocodeAvailableInCache | ( | const String & | source | ) | const
| virtualinherited

Check if a microcode is available for a program in the microcode cache.

Parameters

  name | The name of the program.

## ◆ isSyntaxSupported()

virtual bool Ogre::GpuProgramManager::isSyntaxSupported | ( | const String & | syntaxCode | ) | const
| virtualinherited

Returns whether a given syntax code (e.g.

"ps_1_3", "fp20", "arbvp1") is supported.

## ◆ load() [1/2]

virtual ResourcePtr Ogre::ResourceManager::load | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ load() [2/2]

virtual GpuProgramPtr Ogre::GpuProgramManager::load | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | filename,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode
| ) |  |
| virtualinherited

Loads a GPU program from a file of assembly.

Remarks
  This method creates a new program of the type specified as the second parameter. As with all types of ResourceManager, this class will search for the file in all resource locations it has been configured to look in.

Parameters

  name | The name of the GpuProgram
  groupName | The name of the resource group
  filename | The file to load
  gptype | The type of program to create
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ loadFromString()

virtual GpuProgramPtr Ogre::GpuProgramManager::loadFromString | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | code,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode
| ) |  |
| virtualinherited

Loads a GPU program from a string of assembly code.

Remarks
  The assembly code must be compatible with this manager - call the getSupportedSyntax method for details of the supported syntaxes

Parameters

  name | The identifying name to give this program, which can be used to retrieve this program later with getByName.
  groupName | The name of the resource group
  code | A string of assembly code which will form the program to run
  gptype | The type of program to create.
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ loadMicrocodeCache()

virtual void Ogre::GpuProgramManager::loadMicrocodeCache | ( | DataStreamPtr | stream | ) |
| virtualinherited

Loads the microcode cache from disk.

Parameters

  stream | The source stream

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ parseScript()

virtual void Ogre::ResourceManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName
| ) |  |
| inlinevirtualinherited

Parse the definition of a set of resources from a script file.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

Parameters

  stream | Weak reference to a data stream which is the source of the script
  groupName | The name of the resource group that resources which are parsed are to become a member of. If this group is loaded or unloaded, then the resources discovered in this script will be loaded / unloaded with it.

Implements Ogre::ScriptLoader.

Reimplemented in Ogre::MaterialManager, and Ogre::FontManager.

## ◆ prepare()

virtual ResourcePtr Ogre::ResourceManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ reloadAll() [1/2]

void Ogre::ResourceManager::reloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  reloadableOnly | If true (the default), only reload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't loaded again. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ reloadAll() [2/2]

virtual void Ogre::ResourceManager::reloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources. Additionally, reloading could be done with preserving some selected resource states that could be used elsewhere.

See also
  Resource::LoadingFlags for additional information.

## ◆ reloadUnreferencedResources()

void Ogre::ResourceManager::reloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded but not referenced by any other object resources to be reloaded.

Remarks
  This method behaves like reloadAll, except that it only reloads resources which are not in use, i.e. not referenced by other objects.

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of reloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only reloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## ◆ remove() [1/3]

virtual void Ogre::ResourceManager::remove | ( | const ResourcePtr & | r | ) |
| virtualinherited

Remove a single resource.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [2/3]

virtual void Ogre::ResourceManager::remove | ( | const String & | name | ) |
| virtualinherited

Remove a single resource by name.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [3/3]

virtual void Ogre::ResourceManager::remove | ( | ResourceHandle | handle | ) |
| virtualinherited

Remove a single resource by handle.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeAll()

virtual void Ogre::ResourceManager::removeAll | ( | void |  | ) |
| virtualinherited

Removes all resources.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeMicrocodeFromCache()

virtual void Ogre::GpuProgramManager::removeMicrocodeFromCache | ( | const String & | source | ) |
| virtualinherited

Removes a microcode for a program from the microcode cache.

Parameters

  name | The name of the program.

## ◆ removeUnreferencedResources()

virtual void Ogre::ResourceManager::removeUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| virtualinherited

Remove all resources which are not referenced by any other object.

Remarks
  This method behaves like removeAll, except that it only removes resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, remove or reload that resource will cause dangerous pointer access. Use this function instead of removeAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only removes resources which can be subsequently automatically reloaded.

## ◆ resourceExists() [1/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | const String & | name | ) |
| inlinevirtualinherited

Returns whether the named resource exists in this manager.

## ◆ resourceExists() [2/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | ResourceHandle | handle | ) |
| inlinevirtualinherited

Returns whether a resource with the given handle exists in this manager.

## ◆ saveMicrocodeCache()

virtual void Ogre::GpuProgramManager::saveMicrocodeCache | ( | DataStreamPtr | stream | ) | const
| virtualinherited

Saves the microcode cache to disk.

Parameters

  stream | The destination stream

## ◆ setMemoryBudget()

virtual void Ogre::ResourceManager::setMemoryBudget | ( | size_t | bytes | ) |
| virtualinherited

Set a limit on the amount of memory this resource handler may use.

Remarks
  If, when asked to load a new resource, the manager believes it will exceed this memory budget, it will temporarily unload a resource to make room for the new one. This unloading is not permanent and the Resource is not destroyed; it simply needs to be reloaded when next used.

## ◆ setSaveMicrocodesToCache()

void Ogre::GpuProgramManager::setSaveMicrocodesToCache | ( | const bool | val | ) |
| inherited

Set if the microcode of a shader should be saved to a cache.

## ◆ setVerbose()

virtual void Ogre::ResourceManager::setVerbose | ( | bool | v | ) |
| inlinevirtualinherited

Sets whether this manager and its resources habitually produce log output.

## ◆ unload() [1/2]

virtual void Ogre::ResourceManager::unload | ( | const String & | name | ) |
| virtualinherited

Unloads a single resource by name.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unload() [2/2]

virtual void Ogre::ResourceManager::unload | ( | ResourceHandle | handle | ) |
| virtualinherited

Unloads a single resource by handle.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unloadAll() [1/2]

void Ogre::ResourceManager::unloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  reloadableOnly | If true (the default), only unload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't load them later. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ unloadAll() [2/2]

virtual void Ogre::ResourceManager::unloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources.

See also
  Resource::LoadingFlags for additional information.

## ◆ unloadUnreferencedResources()

void Ogre::ResourceManager::unloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unload all resources which are not referenced by any other object.

Remarks
  This method behaves like unloadAll, except that it only unloads resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of unloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only unloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::ResourceManager::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreD3D11GpuProgramManager.h